from .triofinder import TrioFinder

class MoveChecker():
    def __init__(self, grid):
        self.__grid = grid

    def check_move(self, x1, y1, x2, y2):
        # first check if gems a neighbouring
        if abs(x1 - x2) > 1 or abs(y1 - y2) > 1:
            return False

        if abs(x1 - x2) + abs(y1 - y2) == 2:
            return False

        tf = TrioFinder()
        self.__grid[y2][x2], self.__grid[y1][x1] = self.__grid[y1][x1], self.__grid[y2][x2]

        if tf.find_trios(self.__grid):
            return True

        self.__grid[y2][x2], self.__grid[y1][x1] = self.__grid[y1][x1], self.__grid[y2][x2]
        return False