from random import  randint
from .triofinder import TrioFinder

class JewelsGenerator:
    def __init__(self, number_of_rows, number_of_columns, colors):
        """
        :type number_of_rows: int
        :type number_of_columns: int
        :type colors: tuple
        """

        self.__rows = number_of_rows
        self.__columns = number_of_columns
        self.__colors = colors

    """
    it generates jewels into grid
    returns dict of dict of colors
    """
    def generate_jewels(self):
        grid = { y:{x:None for x in range(0, self.__rows)} for y in range(0, self.__columns)}
        with open("input.txt", "r") as f:
            for y in range(self.__rows):
                line = f.readline().replace("\n", "")
                indexes = map(int, line[::1])
                for k, v in enumerate(indexes):
                    grid[y][k] = self.__colors[v - 1]

        """tf = TrioFinder()

        for y in range(0, self.__columns):
            for x in range(0, self.__rows):
                while tf.find_trios(grid) or grid[y][x] is None:
                    grid[y][x] = self.__colors[randint(0, len(self.__colors) - 1)]"""

        return grid
