from .triofinder import TrioFinder, TrioDirection

class TriosRemover:
    """
    return number of removed trios
    """
    def remove_trios(self, grid):
        tf = TrioFinder()

        trios = tf.find_trios(grid)

        for trio in trios:
            if trio[2] == TrioDirection.Horizontal:
                grid[trio[1]][trio[0]] = None
                grid[trio[1]][trio[0] + 1] = None
                grid[trio[1]][trio[0] + 2] = None
            else:
                grid[trio[1]][trio[0]] = None
                grid[trio[1] + 1][trio[0]] = None
                grid[trio[1] + 2][trio[0]] = None

        return len(trios)