from PyQt5.QtWidgets import QApplication, QWidget
import sys
from graphics.gamewindow import GameWindow
from graphics.timepicker import TimePicker

app = QApplication(sys.argv)
w = GameWindow()
w.setAutoFillBackground(True)
t = TimePicker()

t.start_normal.connect(w.show)
t.start_with_time.connect(w.start_with_time)

t.show()

sys.exit(app.exec_())
